Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 28962)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 28963)
@@ -169,4 +169,5 @@
 
 /* Serial port change event: */
+/* Not used:
 class UISerialPortChangeEvent : public QEvent
 {
@@ -183,6 +184,8 @@
     const CSerialPort m_serialPort;
 };
+*/
 
 /* Parallel port change event: */
+/* Not used:
 class UIParallelPortChangeEvent : public QEvent
 {
@@ -199,6 +202,8 @@
     const CParallelPort m_parallelPort;
 };
+*/
 
 /* Storage controller change event: */
+/* Not used:
 class UIStorageControllerChangeEvent : public QEvent
 {
@@ -208,4 +213,5 @@
         : QEvent((QEvent::Type)UIConsoleEventType_StorageControllerChange) {}
 };
+*/
 
 /* Storage medium change event: */
@@ -225,4 +231,5 @@
 
 /* CPU change event: */
+/* Noz used:
 class UICPUChangeEvent : public QEvent
 {
@@ -241,6 +248,8 @@
     bool m_bRemove;
 };
+*/
 
 /* VRDP server change event: */
+/* Not used:
 class UIVRDPServerChangeEvent : public QEvent
 {
@@ -250,6 +259,8 @@
         : QEvent((QEvent::Type)UIConsoleEventType_VRDPServerChange) {}
 };
+*/
 
 /* Remote display info change event: */
+/* Not used:
 class UIRemoteDisplayInfoChangeEvent : public QEvent
 {
@@ -259,4 +270,5 @@
         : QEvent((QEvent::Type)UIConsoleEventType_RemoteDisplayInfoChange) {}
 };
+*/
 
 /* USB controller change event: */
@@ -406,20 +418,20 @@
     }
 
-    STDMETHOD(OnSerialPortChange)(ISerialPort *pSerialPort)
-    {
-        QApplication::postEvent(m_pEventHandler, new UISerialPortChangeEvent(CSerialPort(pSerialPort)));
-        return S_OK;
-    }
-
-    STDMETHOD(OnParallelPortChange)(IParallelPort *pParallelPort)
-    {
-        QApplication::postEvent(m_pEventHandler, new UIParallelPortChangeEvent(CParallelPort(pParallelPort)));
-        return S_OK;
+    STDMETHOD(OnSerialPortChange)(ISerialPort * /* pSerialPort */)
+    {
+        /* Not used: QApplication::postEvent(m_pEventHandler, new UISerialPortChangeEvent(CSerialPort(pSerialPort))); */
+        return VBOX_E_DONT_CALL_AGAIN;
+    }
+
+    STDMETHOD(OnParallelPortChange)(IParallelPort * /* pParallelPort */)
+    {
+        /* Not used: QApplication::postEvent(m_pEventHandler, new UIParallelPortChangeEvent(CParallelPort(pParallelPort))); */
+        return VBOX_E_DONT_CALL_AGAIN;
     }
 
     STDMETHOD(OnStorageControllerChange)()
     {
-        QApplication::postEvent(m_pEventHandler, new UIStorageControllerChangeEvent);
-        return S_OK;
+        /* Not used: QApplication::postEvent(m_pEventHandler, new UIStorageControllerChangeEvent); */
+        return VBOX_E_DONT_CALL_AGAIN;
     }
 
@@ -430,20 +442,20 @@
     }
 
-    STDMETHOD(OnCPUChange)(ULONG uCPU, BOOL bRemove)
-    {
-        QApplication::postEvent(m_pEventHandler, new UICPUChangeEvent(uCPU, bRemove));
-        return S_OK;
+    STDMETHOD(OnCPUChange)(ULONG /* uCPU */, BOOL /* bRemove */)
+    {
+        /* Not used: QApplication::postEvent(m_pEventHandler, new UICPUChangeEvent(uCPU, bRemove)); */
+        return VBOX_E_DONT_CALL_AGAIN;
     }
 
     STDMETHOD(OnVRDPServerChange)()
     {
-        QApplication::postEvent(m_pEventHandler, new UIVRDPServerChangeEvent);
-        return S_OK;
+        /* Not used: QApplication::postEvent(m_pEventHandler, new UIVRDPServerChangeEvent); */
+        return VBOX_E_DONT_CALL_AGAIN;
     }
 
     STDMETHOD(OnRemoteDisplayInfoChange)()
     {
-        QApplication::postEvent(m_pEventHandler, new UIRemoteDisplayInfoChangeEvent);
-        return S_OK;
+        /* Not used: QApplication::postEvent(m_pEventHandler, new UIRemoteDisplayInfoChangeEvent); */
+        return VBOX_E_DONT_CALL_AGAIN;
     }
 
@@ -1041,4 +1053,5 @@
         }
 
+        /* Not used:
         case UIConsoleEventType_SerialPortChange:
         {
@@ -1047,5 +1060,7 @@
             return true;
         }
-
+        */
+
+        /* Not used:
         case UIConsoleEventType_ParallelPortChange:
         {
@@ -1054,5 +1069,7 @@
             return true;
         }
-
+        */
+
+        /* Not used:
         case UIConsoleEventType_StorageControllerChange:
         {
@@ -1060,4 +1077,5 @@
             return true;
         }
+        */
 
         case UIConsoleEventType_MediumChange:
@@ -1068,4 +1086,5 @@
         }
 
+        /* Not used:
         case UIConsoleEventType_CPUChange:
         {
@@ -1074,5 +1093,7 @@
             return true;
         }
-
+        */
+
+        /* Not used:
         case UIConsoleEventType_VRDPServerChange:
         {
@@ -1080,5 +1101,7 @@
             return true;
         }
-
+        */
+
+        /* Not used:
         case UIConsoleEventType_RemoteDisplayInfoChange:
         {
@@ -1086,4 +1109,5 @@
             return true;
         }
+        */
 
         case UIConsoleEventType_USBControllerChange:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 28962)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 28963)
@@ -49,9 +49,9 @@
     UIConsoleEventType_AdditionsStateChange,
     UIConsoleEventType_NetworkAdapterChange,
-    UIConsoleEventType_SerialPortChange,
-    UIConsoleEventType_ParallelPortChange,
-    UIConsoleEventType_StorageControllerChange,
+    /* Not used: UIConsoleEventType_SerialPortChange, */
+    /* Not used: UIConsoleEventType_ParallelPortChange, */
+    /* Not used: UIConsoleEventType_StorageControllerChange, */
     UIConsoleEventType_MediumChange,
-    UIConsoleEventType_CPUChange,
+    /* Not used: UIConsoleEventType_CPUChange, */
     UIConsoleEventType_VRDPServerChange,
     UIConsoleEventType_RemoteDisplayInfoChange,
@@ -157,11 +157,11 @@
     void sigAdditionsStateChange();
     void sigNetworkAdapterChange(const CNetworkAdapter &networkAdapter);
-    void sigSerialPortChange(const CSerialPort &serialPort);
-    void sigParallelPortChange(const CParallelPort &parallelPort);
-    void sigStorageControllerChange();
+    /* Not used: void sigSerialPortChange(const CSerialPort &serialPort); */
+    /* Not used: void sigParallelPortChange(const CParallelPort &parallelPort); */
+    /* Not used: void sigStorageControllerChange(); */
     void sigMediumChange(const CMediumAttachment &mediumAttachment);
-    void sigCPUChange(ulong uCPU, bool bRemove);
-    void sigVRDPServerChange();
-    void sigRemoteDisplayInfoChange();
+    /* Not used: void sigCPUChange(ulong uCPU, bool bRemove); */
+    /* Not used: void sigVRDPServerChange(); */
+    /* Not used: void sigRemoteDisplayInfoChange(); */
     void sigUSBControllerChange();
     void sigUSBDeviceStateChange(const CUSBDevice &device, bool bIsAttached, const CVirtualBoxErrorInfo &error);