Index: trunk/src/VBox/Frontends/VirtualBox/src/darwin/CocoaDockIconPreview.mm
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/darwin/CocoaDockIconPreview.mm	(revision 29199)
+++ trunk/src/VBox/Frontends/VirtualBox/src/darwin/CocoaDockIconPreview.mm	(revision 29200)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -16,8 +16,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
@@ -67,5 +63,5 @@
 @end
 
-/* 
+/*
  * Helper class which allow us to access all members/methods of AbstractDockIconPreviewHelper
  * from any Cocoa class.
@@ -75,5 +71,5 @@
 public:
     inline CocoaDockIconPreviewPrivate (VBoxConsoleWnd *aMainWnd, const QPixmap& aOverlayImage)
-      :AbstractDockIconPreviewHelper (aMainWnd, aOverlayImage) 
+      :AbstractDockIconPreviewHelper (aMainWnd, aOverlayImage)
     {
         mDockTile = [[DockTile alloc] initWithParent:this];
@@ -84,10 +80,10 @@
         [mDockTile release];
     }
-      
+
     DockTile *mDockTile;
 };
 
-/* 
- * Cocoa wrapper for the abstract dock icon preview class 
+/*
+ * Cocoa wrapper for the abstract dock icon preview class
  */
 CocoaDockIconPreview::CocoaDockIconPreview (VBoxConsoleWnd *aMainWnd, const QPixmap& aOverlayImage)
@@ -135,5 +131,5 @@
 }
 
-/* 
+/*
  * Class for arranging/updating the layers for the glossy monitor preview.
  */
@@ -199,5 +195,5 @@
 @end
 
-/* 
+/*
  * Simple implementation for the overlay of the OS & the state icon. Is used both
  * in the application icon & preview mode.
@@ -222,5 +218,5 @@
 @end
 
-/* 
+/*
  * VirtualBox Dock Tile implementation. Manage the switching between the icon
  * and preview mode & forwards all update request to the appropriate methods.
Index: trunk/src/VBox/Frontends/VirtualBox/src/darwin/UICocoaDockIconPreview.mm
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/darwin/UICocoaDockIconPreview.mm	(revision 29199)
+++ trunk/src/VBox/Frontends/VirtualBox/src/darwin/UICocoaDockIconPreview.mm	(revision 29200)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -16,8 +16,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
@@ -68,5 +64,5 @@
 @end
 
-/* 
+/*
  * Helper class which allow us to access all members/methods of AbstractDockIconPreviewHelper
  * from any Cocoa class.
@@ -76,5 +72,5 @@
 public:
     inline UICocoaDockIconPreviewPrivate(UISession *pSession, const QPixmap& overlayImage)
-      :UIAbstractDockIconPreviewHelper(pSession, overlayImage) 
+      :UIAbstractDockIconPreviewHelper(pSession, overlayImage)
     {
         mUIDockTile = [[UIDockTile alloc] initWithParent:this];
@@ -87,10 +83,10 @@
         [mUIDockTile release];
     }
-      
+
     UIDockTile *mUIDockTile;
 };
 
-/* 
- * Cocoa wrapper for the abstract dock icon preview class 
+/*
+ * Cocoa wrapper for the abstract dock icon preview class
  */
 UICocoaDockIconPreview::UICocoaDockIconPreview(UISession *pSession, const QPixmap& overlayImage)
@@ -137,5 +133,5 @@
 }
 
-/* 
+/*
  * Class for arranging/updating the layers for the glossy monitor preview.
  */
@@ -201,5 +197,5 @@
 @end
 
-/* 
+/*
  * Simple implementation for the overlay of the OS & the state icon. Is used both
  * in the application icon & preview mode.
@@ -224,5 +220,5 @@
 @end
 
-/* 
+/*
  * VirtualBox Dock Tile implementation. Manage the switching between the icon
  * and preview mode & forwards all update request to the appropriate methods.
Index: trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxCocoaSpecialControls.mm
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxCocoaSpecialControls.mm	(revision 29199)
+++ trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxCocoaSpecialControls.mm	(revision 29200)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -16,8 +16,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
@@ -37,5 +33,5 @@
 #include <QKeyEvent>
 
-@interface NSButtonTarget: NSObject 
+@interface NSButtonTarget: NSObject
 {
     VBoxCocoaButton *mRealTarget;
@@ -61,5 +57,5 @@
 @end
 
-@interface NSSegmentedButtonTarget: NSObject 
+@interface NSSegmentedButtonTarget: NSObject
 {
     VBoxCocoaSegmentedButton *mRealTarget;
@@ -85,5 +81,5 @@
 @end
 
-@interface VBSearchField: NSSearchField 
+@interface VBSearchField: NSSearchField
 {
     VBoxCocoaSearchField *mRealTarget;
@@ -110,17 +106,17 @@
 
     /* Get the pressed character */
-    if ([str length] > 0) 
+    if ([str length] > 0)
         ch = [str characterAtIndex:0];
 
-    if (ch == NSCarriageReturnCharacter || ch == NSEnterCharacter) 
+    if (ch == NSCarriageReturnCharacter || ch == NSEnterCharacter)
     {
         QKeyEvent ke(QEvent::KeyPress, Qt::Key_Enter, Qt::NoModifier);
         QApplication::sendEvent (mRealTarget, &ke);
-    } 
+    }
     else if (ch == 27) /* Escape */
     {
         QKeyEvent ke(QEvent::KeyPress, Qt::Key_Escape, Qt::NoModifier);
         QApplication::sendEvent (mRealTarget, &ke);
-    } 
+    }
     else if (ch == NSF3FunctionKey)
     {
@@ -152,10 +148,10 @@
 @end
 @implementation VBSearchFieldDelegate
--(BOOL)control:(NSControl*)control textView:(NSTextView*)textView doCommandBySelector:(SEL)commandSelector 
+-(BOOL)control:(NSControl*)control textView:(NSTextView*)textView doCommandBySelector:(SEL)commandSelector
 {
 //    NSLog (NSStringFromSelector (commandSelector));
     /* Don't execute the selector for Enter & Escape. */
-    if (   commandSelector == @selector(insertNewline:) 
-	    || commandSelector == @selector(cancelOperation:)) 
+    if (   commandSelector == @selector(insertNewline:)
+	    || commandSelector == @selector(cancelOperation:))
 		return YES;
     return NO;
@@ -163,5 +159,5 @@
 @end
 
-@interface VBSearchFieldCell: NSSearchFieldCell 
+@interface VBSearchFieldCell: NSSearchFieldCell
 {
     NSColor *mBGColor;
@@ -173,5 +169,5 @@
 - (void)setBackgroundColor:(NSColor*)aBGColor
 {
-    if (mBGColor != aBGColor) 
+    if (mBGColor != aBGColor)
     {
         [mBGColor release];
@@ -295,5 +291,5 @@
     [mNativeRef setSegmentStyle:NSSegmentStyleRoundRect];
     [[mNativeRef cell] setTrackingMode: NSSegmentSwitchTrackingMomentary];
-    [mNativeRef setFont: [NSFont controlContentFontOfSize: 
+    [mNativeRef setFont: [NSFont controlContentFontOfSize:
         [NSFont systemFontSizeForControlSize: NSSmallControlSize]]];
     [mNativeRef sizeToFit];
@@ -353,5 +349,5 @@
     mNativeRef = [[VBSearchField alloc] initWithObject2: this];
     [[mNativeRef cell] setControlSize: NSSmallControlSize];
-    [mNativeRef setFont: [NSFont controlContentFontOfSize: 
+    [mNativeRef setFont: [NSFont controlContentFontOfSize:
         [NSFont systemFontSizeForControlSize: NSSmallControlSize]]];
     [mNativeRef sizeToFit];
Index: trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxDockIconPreview-cocoa.mm
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxDockIconPreview-cocoa.mm	(revision 29199)
+++ trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxDockIconPreview-cocoa.mm	(revision 29200)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -16,8 +16,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
@@ -91,5 +87,5 @@
     /* Convert the CGImage to an NSImage */
     NSBitmapImageRep *bitmapImageRep = [[NSBitmapImageRep alloc] initWithCGImage:pImage];
-    if (bitmapImageRep) 
+    if (bitmapImageRep)
     {
         NSImage *badgeImage = [[NSImage alloc] initWithSize:[bitmapImageRep size]];
@@ -105,5 +101,5 @@
     /* Set the new application icon */
     [NSApp setApplicationIconImage:gDockIconImage];
-    
+
     [pool release];
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-cocoa.mm
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-cocoa.mm	(revision 29199)
+++ trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-cocoa.mm	(revision 29200)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2009 Sun Microsystems, Inc.
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -17,8 +17,4 @@
  * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
  */
 
@@ -38,5 +34,5 @@
     if (aView)
         window = [aView window];
-    
+
     [pool release];
     return window;
@@ -49,5 +45,5 @@
     NativeViewRef view = NULL;
     if (aWindow)
-        view = [aWindow contentView];   
+        view = [aWindow contentView];
 
     [pool release];
@@ -188,5 +184,5 @@
 {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
-    
+
     bool fResult = [aWindow isZoomed];
 